; File Name: eprommer_2_9_ccl.bin
; Range: 0100h - 0900h Loaded length: 0800h
; reassembliert mit IDAFREE
; aufbereitet fr den AS Macro Assembler as1418
; Assemblieren mit: as -L eprommer.asm, p2bin -r $-$ eprommer.p
; Volker Pohlers 21.02.2003

; Hardware Eprom-Programmiermodul des CC Leipzig (mit PIO) 

		CPU	Z80

KC 		EQU 	1     	; 1 -> Z1013
      				; 9 -> Z9001

OUTCH	MACRO
   	IF KC = 1
		rst	20h
		DEFB 	0		; OUTCH
	ELSE
		call	ccoout
	ENDIF
        ENDM

INCH	MACRO
   	IF KC = 1
		rst	20h
		DEFB 	1		; INCH
	ELSE
		CALL	CCONIN
	ENDIF
        ENDM

INHEX	MACRO
   	IF KC = 1
		rst	20h
		DEFB 	3		; INHEX
	ELSE
		CALL	CINHEX
	ENDIF
        ENDM

INKEY	MACRO
   	IF KC = 1
		rst	20h
		DEFB 	4		; INKEY
	ELSE
		push	bc
		LD	C,11		; CSTS
		CALL	5
		pop	bc
	ENDIF
        ENDM

PRST7	MACRO
   	IF KC = 1
		rst	20h
		DEFB 	2		; PRST7
	ELSE
		call	cprst7
	ENDIF
        ENDM

OUTHX	MACRO
   	IF KC = 1
		rst	20h
		DEFB 	6		; OUTHX
	ELSE
		call	COUTHX
	ENDIF
        ENDM

OUTHL	MACRO
   	IF KC = 1
		rst	20h
		DEFB 	7		; OUTHL
	ELSE
		call	COUTHL
	ENDIF
        ENDM


	IF KC = 1		; - Z1013

SOIL		EQU	00016H	; Anfangsadresse Eingabepuffer
ARG1		EQU	0001BH
ARG2		EQU	0001DH
CURSR		EQU	0002BH	; aktuelle Cursorposition
SCREEN		EQU	0EC00H	; Screen-Start
SCSIZ		EQU	00400H	; Screen-Groesse
	ELSE			; -- Z9001

		ORG	0300H

P1ROL		EQU	0003BH
CURSR		EQU	0002DH	; CURS aktuelle Cursorposition
SCREEN		EQU	0EC00H	; Screen-Start
CONIN		EQU	0F009H	; Eingabe 1 Zeichen (A) von CONST
CONSO		EQU	0F00CH	; Ausgabe 1 Zeichen (C) zu CONST
	ENDIF

PIO_DA		EQU	0FCH	; Daten Kanal A - Datenbus
PIO_STA		EQU	0FDH	; Steuerwort Kanal A
PIO_DB		EQU	0FEH	; Daten Kanal B
PIO_STB		EQU	0FFH	; Steuerwort Kanal B

; PB7	Fertigsignal
; PB6	Programmierimpuls
; PB5	CS/WE bzw. OE
; PB4	Zuschalten UPP
; PB3	Zuschalten UCE, U00
; PB2	Zhler rcksetzen
; PB1	
; PB0	Zhler

   	IF KC = 1
		ORG	0100H

		jr	start
		DEFB	"Rainer Brosig,COSWIG 8270,Florin 2c"

byte_0125:	DEFB	0
modus:		DEFB	0		; Programmmodus	(1..5)
byte_0127:	DEFB	0
byte_0128:	DEFB	0
eprom_size:	DEFW	0
eprom_von:	DEFW	0
eprom_bis:	DEFW	0
ramadr:		DEFW	0		; Ablagebereich	ROM-Inhalt im Speicher

   	ELSE
		org	160h		

DATA:		DEFW	0		
SOIL:		DEFW	0
byte_0125:	DEFB	0
modus:		DEFB	0		; Programmmodus	(1..5)
byte_0127:	DEFB	0
byte_0128:	DEFB	0
eprom_size:	DEFW	0
eprom_von:	DEFW	0
eprom_bis:	DEFW	0
ramadr:		DEFW	0		; Ablagebereich	ROM-Inhalt im Speicher

		org	0d000h	; ROM-Version

		JP	start
		DEFB	"EPROMMER"
		;DEFB	"E       "
		DEFW	0

		DEFB	"Rainer Brosig & Volker Pohlers"
   	ENDIF

start:
		ld	a, 0CFh
		out	(PIO_STB), a
		ld	a, 80h
		out	(PIO_STB), a
		ld	a, 20h
		out	(PIO_DB), a
		ld	a, 25h
		out	(PIO_DB), a
   	IF KC = 1
		prst7
		DEFB 	0Ch
		DEFB 	0Dh
		DEFB	0Dh
		DEFB	"  *** EPROM-Handler V.2.9 *** "
		DEFB	0Dh
		DEFB	0Dh
		DEFB	8Dh

                ld      hl, SCREEN+00A0H
                ld      (ARG1), hl
		ld	hl, SCREEN+0400H
		ld	(ARG2), hl
		rst	20h
		DEFB 	0Bh		; WIND,	Rollfenster festlegen
	ELSE
		prst7
		DEFB 	0Ch
		DEFB	"  *** EPROM-Handler V.2.9 *** "
		DEFB	8Dh

		ld	a,2
		ld	(P1ROL), A	; Fenster ab 3. Zeile
   	ENDIF
		PRST7
		DEFB	0Ch
		DEFB	0Dh
		DEFB	"EPROM-Typ? :"
		DEFB 	0A0h
		call	inphex		; Zahl einlesen	(Eprom-Typ)
		ld	a, l
		or	h
		jr	z, start	; Fehler bei 0
		push	hl
		ld	hl, (SOIL)	; SOIL, anfangsadresse der Eingabezeile
start1:					; 5 Zeichen (EpromTyp) auf den Bildschirm poken
	IF KC = 1
		ld	de, SCREEN+2*20h+0014h
	ELSE
		ld	de, SCREEN+0*40+0014h
	ENDIF
		ld	bc, 5
		ldir
		pop	hl
		ld	a, l		; vom Eprom-Typ	werden nur die letzten beiden Stellen getestet
		cp	55h		; 555
		ld	hl, 400h	; EPROM-Groesse
		jr	nz, start2
		jr	start4
start2:					; 2708
		cp	8
		jr	nz, start3
		jr	start4
start3:					; 2716
		cp	16h
		add	hl, hl
		jr	z, start4
		cp	32h		; 2732
		add	hl, hl
		jr	z, start4
		cp	64h		; 2764
		add	hl, hl
		jr	z, start4
		cp	28h		; 27128
		add	hl, hl
		jr	z, start4
		cp	56h		; 27256
		add	hl, hl
		jr	z, start4
		jp	start
start4:					; Groesse des Eproms merken
		ld	(eprom_size), hl
start5:
	IF KC = 1	
		ld	sp, 0B0h
	ENDIF
		call	sub_0800
		call	sub_0899
		PRST7
		DEFB	0Ch
		DEFB	0Dh
		DEFB	"     Fassung spannungslos!"
		DEFB	0Dh
		DEFB	0Dh
		DEFB	0Dh
		DEFB	"Mode:"
		DEFB	0Dh
		DEFB	"====="
		DEFB	0Dh
		DEFB	0Dh
		DEFB	0Dh
		DEFB	"     Lesen.........1"
		DEFB	0Dh
		DEFB	0Dh
		DEFB	"     Programmieren.2"
		DEFB	0Dh
		DEFB	0Dh
		DEFB	"     Vergleichen...3"
		DEFB	0Dh
		DEFB	0Dh
		DEFB	"     Loeschtest....4"
		DEFB	0Dh
		DEFB	0Dh
		DEFB	"     Wiederholen...5"
		DEFB	0Dh
		DEFB	0Dh
		DEFB	"     Fortsetzen....6"
		DEFB	0Dh
		DEFB	0Dh
		DEFB	0Dh
		DEFB	"Funktionswahl nach Kennziffer:"
		DEFB	0A0h
start7:
		INCH
		cp	3		; STOP-Taste gedrueckt?
		jr	z, start8
		cp	'N'             ; N gedrueckt?
		jr	z, start8
		jr	start9
start8:
	IF KC = 1
		push	af
		ld	hl, 0EC00h
		ld	(ARG1), hl
		ld	hl, 0F000h
		ld	(SOIL+1), hl; ????? Fehler -> ARG2 korrekt (vp)
		rst	20h
		DEFB 	0Bh		; WIND,	Rollfenster festlegen
	ELSE
		push	af
		ld	a,0
		ld	(P1ROL), A	; Fenster ab 1. Zeile
	ENDIF
		pop	af
		cp	'N'
		jp	z, start	; Bei N	Neustart
		jp	0F000h		; Bei STOP zur?ck zum Betriebssystem

start9:					; Fehler wenn <	1
		cp	'1'
		jr	c, start7
		cp	'5'
		jp	nc, smode	; UP-Aufruf bei	Zahl 1..5
		OUTCH			; Mode ausgeben
		ld	(modus), a
		prst7
		DEFB	0Dh
		DEFB	0Dh
		DEFB	"gesamten Speicherbereich "
		DEFB	0Dh
		DEFB	0Dh
		DEFB	"des EPROM ? (N/ENT)"
		DEFB	0A0h
		INCH
		cp	3		; Stop-Taste gedrueckt?
		jp	z, start5
		cp	0Dh		; ENTER-Taste gedrueckt
		jr	nz, start6
		ld	a, 0Ch		; CLS ausgeben (Bildschirm l"schen)
		OUTCH
		ld	hl, (eprom_size)
		dec	hl
		ld	(eprom_bis), hl
		ld	hl, 0
		ld	(eprom_von), hl
		jp	start10
start6:
		prst7
		DEFB	0Ch
		DEFB	0Dh
		DEFB	0Dh
		DEFB	0Dh
		DEFB	"rel. EPROM-Adressbereich (HEX)"
		DEFB	0Dh
		DEFB	0Dh
		DEFB	0Dh
		DEFB	0Dh
		DEFB	"  von:"
		DEFB	0A0h
		call	inphex
		ld	bc, (eprom_size)
		push	hl
		or	a
		sbc	hl, bc
		pop	hl
		jp	nc, start6
		ld	(eprom_von), hl
		prst7
		DEFB	0Dh
		DEFB	"  bis:"
		DEFB	0A0h
		call	inphex
		ld	bc, (eprom_von)
		push	hl
		or	a
		sbc	hl, bc
		pop	hl
		jp	c, start6
		push	hl
		ld	bc, (eprom_size)
		sbc	hl, bc
		jp	nc, start6
		pop	hl
		ld	(eprom_bis), hl

start10:
		ld	a, (modus)
		cp	'1'
		jp	z, up_lesen	; Lesen
		cp	'2'
		jp	z, up_lesen3	; Programmieren
		cp	'3'
		jp	z, up_vergl	; Vergleichen

up_test:				; Mode 4: L"schtest
		call	sub_0879
		ld	a, (byte_0127)
		or	a
		jr	z, loc_03E9
		call	sub_0851
		call	sub_07F4
		call	sub_05E7

loc_03B5:
		in	a, (PIO_DA)
		cp	0FFh
		jr	z, loc_03DB
		push	af
		prst7
		DEFB	0Dh
		DEFB	"no blank:"
		DEFB	0A0h
		ld	h, b
		ld	l, c
		OUTHL
	IF KC = 1
		rst	20h
		DEFB 	0Eh		; OUTSP
		rst	20h
		DEFB 	0Eh		; OUTSP
	ELSE
		LD	A, ' '
		CALL	ccoout
		CALL	ccoout
	ENDIF;
		pop	af
		OUTHX		
		INCH
                cp      3	; STOP gedrueckt?
		jp	z, start5

loc_03DB:
		call	sub_05F3
		jr	z, loc_03E9
		inc	bc
		call	sub_086E

loc_03E4:
		dec	a
		jr	nz, loc_03E4
		jr	loc_03B5

loc_03E9:
		call	sub_0800
		prst7
		DEFB	0Dh
		DEFB	0Dh
		DEFB	0Dh
		DEFB	"OK"
		DEFB	0Dh
		DEFB	0A0h
		INCH
		jp	start5
;
;Mode 1: Lesen
;

up_lesen:
		prst7
		DEFB	0Dh
		DEFB	0Dh
		DEFB	0Dh
		DEFB	"nach"
		DEFB	0A0h
		call	sub_07D5

up_lesen1:
		call	sub_0851
		call	sub_07F4
		call	sub_05E7

up_lesen2:
		in	a, (PIO_DA)
		ld	(hl), a
		call	sub_086E
		call	sub_05F3
		inc	hl
		inc	bc
		jr	nz, up_lesen2
		call	CRC		; CRC-Berechnung
		jp	start5

up_lesen3:
		call	sub_0879
		ld	a, (byte_0127)
		or	a
		jr	z, up_prog
		call	sub_07B9
		INCH
		cp	'J'
		jp	nz, start5
;
;Mode 2: Programmieren
;

up_prog:
		PRST7
		DEFB	0Dh
		DEFB	0Dh
		DEFB	0Dh
		DEFB	20h
		DEFB	"von"
		DEFB	0A0h
		call	sub_07D5

up_prog1:
		call	sub_0851
		call	sub_07F4
		call	sub_05E7

up_prog2:
		call	up_prog3
		call	sub_086E
		call	sub_05F3
		jr	z, up_prog4
		inc	hl
		inc	bc
		jp	up_prog2

up_prog3:
		push	bc
		in	a, (PIO_DA)
		ld	(byte_0128), a
		ld	b, a
		ld	a, (hl)
		xor	b
		ld	b, a
		ld	a, (hl)
		and	b
		pop	bc
		ret	z
		PRST7
		DEFB	0Ch
		DEFB	0Dh
		DEFB	0Dh
		DEFB	"Unvertraeglichkeit!  R       E"
		DEFB	0Dh
		DEFB	0Dh
		DEFB	"EPROM-Zelle:"
		DEFB	0A0h
		push	hl
		ld	h, b
		ld	l, c
		OUTHL
                pop     hl
                push    hl
                prst7
		DEFB	"  "
		DEFB	0A0h
		ld	a, (hl)
		OUTHX		
		PRST7
		DEFB	" <-#->"
		DEFB	0A0h
		ld	a, (byte_0128)
		OUTHX
		PRST7
		DEFB	0Dh
		DEFB	0Dh
		DEFB	8Dh
		INCH
		cp	3	; STOP gedrueckt?
		pop	hl
		ret	nz
		jp	start5

up_prog4:
		PRST7
		DEFB	0Ch
		DEFB	0Dh
		DEFB	0Dh
		DEFB	0Dh
		DEFB	"       Programmierung!"
		DEFB	0Dh
		DEFB	"      ================"
		DEFB	0Dh
		DEFB	0Dh
		DEFB	0Dh
		DEFB	"   "
		DEFB	0A0h
		ld	a, 8Ch
		OUTCH
		PRST7
		DEFB	" - Programmierzyklus"
		DEFB	0Dh
		DEFB	0Dh
		DEFB	"   "
		DEFB	0A0h
		ld	a, 0CFh
		OUTCH
		PRST7
		DEFB	" - Sicherheitszyklus"
		DEFB	0Dh
		DEFB	0Dh
	IF KC = 1
		DEFB	0Dh
		DEFB	0A0h
		ld	hl, (CURSR)	; CURSR, aktuelle Cursorposition
		dec	hl
		ld	(CURSR), hl	; CURSR, aktuelle Cursorposition
	ELSE
		DEFB	8Dh
	ENDIF
		xor	a
		ld	(byte_0125), a

up_prog5:
		xor	a
		ld	(byte_0127), a
		ld	a, 8Ch
		OUTCH
		call	sub_05D3
		call	sub_05A1
		ld	a, (byte_0127)
		or	a
		jr	z, up_prog6
		push	hl
		ld	hl, byte_0125
		inc	(hl)
		ld	a, (hl)
		cp	100		; max 100 Zyklen
		pop	hl
		jr	nz, up_prog5
		jp	up_vergl1

up_prog6:
		ld	a, (byte_0125)
		cp	3
		jr	nc, up_prog7
		ld	a, 3

up_prog7:
		sla	a
		sla	a
		ld	b, a

up_prog8:
		push	bc
		ld	a, 0CFh
		OUTCH
		call	sub_05D3
		pop	bc
		djnz	up_prog8
		call	sub_05A1
		ld	a, (byte_0127)
		or	a
		jp	nz, up_vergl1
		call	CRC
		jp	start5

;
;Warteschleife, ca. 70ms (bei 2MHz Taktfrequenz)
;
wait:
		push	de
	IF KC = 1	
		ld	de, 2000h
	ELSE
		ld	de, 2500h	
	ENDIF
wait1:
		dec	e
		jr	nz, wait1
		dec	d
		jr	nz, wait1
		pop	de
		ret


sub_05A1:
		call	sub_0899
		ld	a, 0Ch
		out	(PIO_DB), a
		call	wait
		call	sub_0851
		in	a, (PIO_DB)
		set	5, a
		out	(PIO_DB), a
		call	sub_05E7
		xor	a
		ld	(byte_0127), a

loc_05BB:
		call	up_prog3
		in	a, (PIO_DA)
		cp	(hl)
		jr	z, loc_05C8
		ld	a, 0FFh
		ld	(byte_0127), a

loc_05C8:
		call	sub_086E
		call	sub_05F3
		ret	z
		inc	bc
		inc	hl
		jr	loc_05BB


sub_05D3:
		call	sub_0600
		call	sub_05E7

loc_05D9:
		call	sub_060B
		call	sub_086E
		call	sub_05F3
		ret	z
		inc	bc
		inc	hl
		jr	loc_05D9

sub_05E7:
		ld	hl, (ramadr)
		ld	bc, (eprom_von)
		ld	de, (eprom_bis)
		ret

sub_05F3:
		push	hl
		ld	h, 8
loc_05F6:
		dec	h
		jr	nz, loc_05F6
		ld	h, b
		ld	l, c
		or	a
		sbc	hl, de
		pop	hl
		ret

sub_0600:
		call	sub_0851
		ld	a, 1Ch
		out	(PIO_DB), a
		call	wait
		ret

;
; Zellenprogrammierung
;
sub_060B:
		ld	a, (hl)
		cp	0FFh
		jr	z, locret_063E
		call	sub_0892
		ld	a, 1Ch
		out	(PIO_DB), a
		ld	a, (hl)
		out	(PIO_DA), a
		ld	a, 5Ch
		out	(PIO_DB), a
		ld	a, 20h

loc_0620:
		dec	a
		jr	nz, loc_0620

loc_0623:
		push	hl
		push	bc
		push	de
		INKEY
		pop	de
		pop	bc
		pop	hl
		cp	3		; STOP-Taste gedrueckt?
		jr	nz, loc_0638
		call	sub_0800
		call	sub_0899
		jp	start5

loc_0638:
		in	a, (PIO_DB)
		bit	7, a
		jr	nz, loc_0623

locret_063E:
		ret

sub_063F:
		call	sub_0899
		in	a, (PIO_DB)
		set	5, a
		out	(PIO_DB), a
		in	a, (PIO_DA)
		ld	(byte_0128), a
		ret
; End of function sub_063F


up_vergl:
		PRST7
		DEFB	0Dh
		DEFB	0Dh
		DEFB	0Dh
		DEFB	" Vergleich mit"
		DEFB	0Dh
		DEFB	0Dh
		DEFB	0A0h	; 
		call	sub_07D5

up_vergl1:
		in	a, (PIO_DB)
		res	4, a
		set	3, a
		out	(PIO_DB), a
		call	sub_063F
		call	wait
		call	sub_0851
		call	sub_05E7
		xor	a
		ld	(byte_0127), a

up_vergl2:
		in	a, (PIO_DA)
		ld	(byte_0128), a
		cp	(hl)
		call	nz, sub_06DB
		call	sub_086E
		call	sub_05F3
		jr	z, up_vergl3
		inc	hl
		inc	bc
		jr	up_vergl2

up_vergl3:
		call	sub_0800
		PRST7
		DEFB	0Dh
		DEFB	0Dh
		DEFB	0Dh
		DEFB	" OK"
		DEFB	0A0h
		INCH
		jp	start5

smode:
		cp	'7'
		jp	nc, start7	; Mode > 6 ist nicht erlaubt
		cp	'6'             ; Fortsetzen
		jr	nz, smode1
		or	a
		ld	hl, (eprom_bis)
		ld	bc, (eprom_von)
		sbc	hl, bc
		ld	bc, (ramadr)
		inc	hl
		add	hl, bc
		ld	(ramadr), hl

smode1:
		ld	a, (modus)
		cp	'1'
		jp	z, up_lesen1
		cp	'2'
		jp	z, up_prog1
		cp	'3'
		jp	z, up_vergl1
		cp	'4'
		jp	z, up_test
		jp	start5


sub_06DB:
		ld	a, (byte_0127)
		or	a
		jr	nz, loc_0736
		PRST7
		DEFB	0Ch
		DEFB	0Dh
		DEFB	0Dh
		DEFB	"     ungleiche Zellen:"
		DEFB	0Dh
		DEFB	0Dh
		DEFB	0Dh
		DEFB	"   EPROM            RAM"
		DEFB	0Dh
		DEFB	0Dh
		DEFB	" Adr.  Inh.      Adr.  Inh."
		DEFB	0Dh
		DEFB	0Dh
		DEFB	0A0h

loc_0736:
		push	hl
		push	bc
		pop	hl
		OUTHL
		PRST7
		DEFB	"  "
		DEFB	0A0h
		ld	a, (byte_0128)
		OUTHX
		PRST7
		DEFB	"      "
		DEFB	0A0h
		pop	hl
		OUTHL
		PRST7
		DEFB	"  "
		DEFB	0A0h
		ld	a, (hl)
		OUTHX
		PRST7
		DEFB	0Dh
		DEFB	0A0h
		ld	a, 0FFh
		ld	(byte_0127), a
		INCH
		cp	3		; STOP-Taste gedrueckt?
		jp	z, start5
		ret


pr_bereich:
		PRST7
		DEFB	0Ch
		DEFB	0Dh
		DEFB	0Dh
		DEFB	0Dh
		DEFB	" EPROM auf gewaehltem Bereich"
		DEFB	0Dh
		DEFB	0Dh
		DEFB	0A0h
		ret

pr_geloescht:
		PRST7
		DEFB	"geloescht !"
		DEFB	0Dh
		DEFB	0Dh
		DEFB	0A0h
		ret


pr_nicht_gel:
		PRST7
		DEFB	"nicht geloescht !"
		DEFB	0Dh
		DEFB	0Dh
		DEFB	0A0h
		ret


sub_07B9:
		PRST7
		DEFB	"trotzdem weiter ? (J/N) "
		DEFB	0A0h	; 
		ret

sub_07D5:
		PRST7
		DEFB	"RAM-Adresse (HEX) ? :"
		DEFB	0A0h	; 
		call	inphex
		ld	(ramadr), hl
		ret

sub_07F4:
		push	af
loc_07F5:
		in	a, (PIO_DB)
		set	3, a
		out	(PIO_DB), a
		call	wait
		pop	af
		ret

sub_0800:
		in	a, (PIO_DB)
		and	0E7h
		out	(PIO_DB), a
		call	wait
		res	2, a
loc_080B:
		out	(PIO_DB), a
		ld	a, 20h
		out	(PIO_DB), a
		ret

sub_0812:
		call	sub_0899
		xor	a
		ld	(byte_0127), a
		call	sub_0851
		call	sub_07F4
		call	sub_05E7
loc_0822:
		in	a, (PIO_DA)
		cp	0FFh
		jr	z, loc_082D
loc_0828:
		ld	a, 0FFh
		ld	(byte_0127), a
loc_082D:
		call	sub_086E
		call	sub_05F3
		ret	z
		inc	bc
		jr	loc_0822
		
inphex:
		ld	hl, (CURSR)
		ld	(SOIL), hl
inhex1:
		INCH
		cp	3		; STOP-Taste gedrueckt?
		jp	z, start5
		OUTCH
		cp	0Dh		; ENTER-Taste gedrueckt?
		jr	nz, inhex1
		ld	de, (SOIL)
		INHEX
		ret


sub_0851:
		in	a, (PIO_DB)
		res	2, a
		out	(PIO_DB), a
		set	2, a
		out	(PIO_DB), a
		or	a
		ld	bc, (eprom_von)

loc_0860:
		ld	hl, 0
		adc	hl, bc
		jr	z, locret_086D
		call	sub_086E
		dec	bc
		jr	loc_0860
locret_086D:
		ret


sub_086E:
		in	a, (PIO_DB)
		set	0, a
		out	(PIO_DB), a
		res	0, a
		out	(PIO_DB), a
		ret

sub_0879:
		call	pr_bereich
		call	sub_0812
		ld	a, (byte_0127)
		or	a
		jp	z, loc_088B
		call	pr_nicht_gel
		jr	loc_088E
loc_088B:
		call	pr_geloescht
loc_088E:
		call	sub_0800
		ret

sub_0892:
		ld	a, 0CFh
		out	(PIO_STA), a
		xor	a
		jr	loc_089F

sub_0899:
		ld	a, 0CFh
		out	(PIO_STA), a
		ld	a, 0FFh
loc_089F:
		out	(PIO_STA), a
		ret
;
;CRC-Berechnung
;
CRC:
		call	sub_0800
		or	a
		ld	hl, (eprom_bis)
		ld	bc, (eprom_von)
		sbc	hl, bc
		ld	b, h
		ld	c, l
		inc	bc
		ld	hl, (ramadr)
		ld	de, 0FFFFh

CRC1:
		ld	a, (hl)
		xor	d
		ld	d, a
		rrca
		rrca
		rrca
		rrca
		and	0Fh
		xor	d
		ld	d, a
		rrca
		rrca
		rrca
		push	af
		and	1Fh
		xor	e
		ld	e, a
		pop	af
		push	af
		rrca
		and	0F0h
		xor	e
		ld	e, a
		pop	af
		and	0E0h
		xor	d
		ld	d, e
		ld	e, a
		inc	hl
		dec	bc
		ld	a, b
		or	c
		jr	nz, CRC1
		ld	h, d
		ld	l, e
		PRST7
		DEFB	0Dh
		DEFB	0Dh
		DEFB	"CRC-CHECK:"
		DEFB	0A0h
		OUTHL
		PRST7
		DEFB	0Dh
		DEFB	0Dh
		DEFB	"OK"
		DEFB	0Dh
		DEFB	8Dh
		INCH
		ret

   	IF KC = 1
		DEFB 	0C9h
		DEFB	"MOS"
	ENDIF

;-------------------------------------------------
; Anpassung der Z1013-Routinen an Z9001
;-------------------------------------------------

	IF KC = 9
;
; Ausgabe bis Bit7 gesetzt
;
CPRST7:		EX	(SP),HL		;Adresse hinter CALL
PRS1:		LD	A,(HL)
		INC	HL
		PUSH	AF
		AND	07FH
		CALL	ccoout
		POP	AF
		BIT	7,A		;Bit7 gesetzt?
		JR	Z,PRS1		;nein
		EX	(SP),HL		;neue Returnadresse
		RET
;
;Ausgabe A
;
ccoout:		PUSH	AF
		PUSH	BC
		push	de
		push	hl
		LD	C,A
		PUSH	AF
		CALL	CONSO
		pop	AF
		CP	0DH
		JR	NZ,ccoout1
		LD	C,0AH
		CALL	CONSO
ccoout1:	POP	hl
		POP	de
		POP	BC
		POP	AF
		ret
;
;Eingabe A
;
cconin:		PUSH	BC
		push	de
		push	hl
		CALL	CONIN
		POP	hl
		POP	de
		POP	BC
		ret


;
;letzen vier Zeichen im Buffer ab DE als Hexzahl konvertieren
;und in DATA ablegen
;
KONVX:		LD	A,(DE)		;fuehrende Leerzeichen ueberlesen
		CP	' '
		JR	NZ,KON0
		INC	DE
		JR	KONVX
;
KON0:		XOR	A
		LD	HL,DATA
		LD	(HL),A		;DATA=0
		INC	HL
		LD	(HL),A
KON1:		LD	A,(DE)
		DEC	HL
		SUB	30H		;Zeichen<"0"?
		RET	M
		CP	0AH		;Zeichen<="9"?
		JR	C,KON2
		SUB	7
		CP	0AH		;Zeichen<"A"?
		RET	M
		CP	10H		;Zeichen>"F"?
		RET	P
KON2:		INC	DE		;Hexziffer eintragen
		RLD
		INC	HL
		RLD
		JR	KON1		;naechste Ziffer
;
;Konvertierung ASCII-Hex ab (DE) --> (HL)
;
CINHEX:		PUSH	BC
		CALL	KONVX		;Konvertierung
		LD	B,H		;BC=HL=DATA+1
		LD	C,L
		LD	L,(HL)		;unteres Byte 
		INC	BC
		LD	A,(BC)
		LD	H,A		;oberes Byte
		OR 	L		;Z-Flag setzen
		POP	BC
		RET
;
;Ausgabe (A) hexadezimal
;
COUTHX:		PUSH	AF
		RRA
		RRA
		RRA
		RRA
		CALL	OUX1		;obere Tetrade ausgeben
		POP	AF		;und die untere
OUX1:		PUSH	AF
		AND	0FH
		ADD	A,30H		;Konvertierung --> ASCII
		CP	':'		;Ziffer "A" ... "F"?
		JR	C,OUX2		;nein
		ADD	A,7		;sonst Korrektur
OUX2:		CALL	ccoout		;und Ausgabe
		POP	AF
		RET
;
;Ausgabe HL hexadezimal
;
COUTHL:		PUSH	AF
		LD	A,H
		CALL	COUTHX
		LD	A,L
		CALL	COUTHX
		POP	AF
		RET

	ENDIF

		end	start
